<template>
  <nav class="vlue-content-component-nav-menu">
    <ul>
      <li v-for="(page, index) in pageNamesWithParentPageNames"
        v-if="!page.parentPageName"
        :class="{ vertical: props.alignVertical }">
        <a class="vlue-content-component-nav-menu-link"
          :class="{ selected: isPageOrParentPageSelected(index) }"
          :href="page.pageName + '.html'"
          :style="cssVars"
          v-on:click="itemClicked(page.pageName, $event)">
          {{page.pageName}}
          <div class="vlue-content-component-nav-menu-underscore"
            :style="cssVars">
          </div>
        </a>
        <div class="vlue-content-component-nav-menu-sub-pages"
          :class="{
            horizontal: props.alignVertical,
            reversed:   props.reverseSubPageMenu,
          }">
          <a class="vlue-content-component-nav-menu-link"
            v-for="(subPage, subIndex) in pageNamesWithParentPageNames"
            :class="{ selected:  isPageOrParentPageSelected(subIndex) }"
            v-if="subPage.parentPageName == page.pageName"
            :href="subPage.pageName + '.html'"
            :style="cssVars"
            v-on:click="itemClicked(subPage.pageName, $event)">
            {{subPage.pageName}}
            <div class="vlue-content-component-nav-menu-underscore"
              :style="cssVars">
            </div>
          </a>
        </div>
      </li>
    </ul>
  </nav>
</template>

<script lang="ts">
import Vue from 'vue'
import store from '../../../store/store'
import { mapGetters } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapGetters([
      'pageNamesWithParentPageNames',
      'currentAndParentPageContainerIndexes',
    ]),
    cssVars() {
      return {
        '--nav-menu-color-a': this.props.colorA,
        '--nav-menu-color-b': this.props.colorB,
      }
    },
  },
  props: {
    props: Object,
  },
  methods: {
    isPageOrParentPageSelected(index) {
      return (this.currentAndParentPageContainerIndexes.indexOf(index) != -1);
    },
    itemClicked(pageName, event) {
      // prevent page reload
      event.preventDefault();
      // update current page
      store.commit('setProperty', {
        property: {
          name: 'currentPage',
        },
        value: pageName,
      });
    },
  },
  mounted() {
    // component properties with types and default values
    this.$emit('mounted', [
      {
        name: 'alignVertical',
        type: 'flag',
        value: false,
      },
      {
        name: 'reverseSubPageMenu',
        type: 'flag',
        value: false,
      },
      {
        name: 'colorA',
        type: 'color',
        value: 'white',
      },
      {
        name: 'colorB',
        type: 'color',
        value: '#0009',
      },
    ]);
  },
})
</script>

<style lang="scss">
@import "../../../style/vars.scss";

.vlue-content-component-nav-menu {
  width: fit-content;
  ul li {
    display: flex;
    position: relative;
    display: inline-block;
    &.vertical {
      display: block;
    }
    .vlue-content-component-nav-menu-sub-pages {
      position: absolute;
      display: flex;
      flex-direction: column;
      z-index: 10;
      opacity: 0;
      pointer-events: none;
      transition: $vlue-transition-duration;
      overflow: hidden;
      padding-top: 10px;
      &.reversed:not(.horizontal) {
        transform: translateY(-100%);
        top: 0;
      }
      &.horizontal:not(.reversed) {
        left: 100%;
      }
      &.horizontal {
        padding: 0;
        top: 0;
        &.reversed {
          right: 100%;
        }
      }
      a {
        margin: 0;
        padding: 20px 30px;
        overflow: hidden;
        &:first-child {
          border-radius: 10px 10px 0 0;
        }
        &:last-child {
          border-radius: 0 0 10px 10px;
        }
        &:hover,
        &.selected {
          color: var(--nav-menu-color-b);
          .vlue-content-component-nav-menu-underscore {
            background: var(--nav-menu-color-a);
          }
        }
        .vlue-content-component-nav-menu-underscore {
          background: var(--nav-menu-color-b);
          height: 100%;
          width: 100%;
          top: 0;
          left: 0;
          right: 0;
          bottom: 0;
          z-index: -1;
          opacity: 1;
        }
      }
    }
    &:hover {
      .vlue-content-component-nav-menu-sub-pages {
        opacity: 1;
        pointer-events: auto;
      }
    }
    > a .vlue-content-component-nav-menu-underscore {
      background: var(--nav-menu-color-a);
    }
    a {
      display: block;
      color: var(--nav-menu-color-a);
      list-style: none;
      padding: 20px;
      transition: $vlue-transition-duration;
      text-decoration: none;
      margin: 0 10px;
      position: relative;
      white-space: nowrap;
      .vlue-content-component-nav-menu-underscore {
        position: absolute;
        bottom: 0;
        left: 50%;
        right: 50%;
        height: 10px;
        opacity: 0;
        transition: $vlue-transition-duration;
      }
      &:hover .vlue-content-component-nav-menu-underscore,
      &.selected .vlue-content-component-nav-menu-underscore {
        left: 0;
        right: 0;
        opacity: 1;
      }
    }
  }
}
</style>
